<?php
/**
* @version      2.2.0 08.09.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

defined('_JEXEC') or die( 'Restricted access' );
jimport('joomla.application.component.model');

class jshopCart{
    
    var $type_cart = "cart"; //cart,wishlist
    var $products = array();
    var $count_product = 0;
    var $price_product = 0;
    var $summ = 0;
    var $rabatt_id = 0;
    var $rabatt_value = 0;
    var $rabatt_type = 0;
    var $rabatt_summ = 0;
    var $rabatt_tax = 0;
    var $rabatt_tax_summ = 0;
    
    function load($type_cart = "cart") {
        $jshopConfig = &JSFactory::getConfig();
        $this->type_cart = $type_cart;
                
        if(isset($_SESSION[$this->type_cart])) {        
            $temp_cart = unserialize($_SESSION[$this->type_cart]);            
            $this->products = $temp_cart->products;
            $this->rabatt_id = $temp_cart->rabatt_id;
            $this->rabatt_value = $temp_cart->rabatt_value;
            $this->rabatt_type = $temp_cart->rabatt_type;
            $this->rabatt_summ = $temp_cart->rabatt_summ;
            $this->rabatt_tax = $temp_cart->rabatt_tax;
            $this->rabatt_tax_summ = $temp_cart->rabatt_tax_summ;
        }
        
        if(isset($_COOKIE['jshopping_temp_cart']) && $this->type_cart=='wishlist' && !count($this->products)) {
            $_tempcart = &JModel::getInstance('tempcart', 'jshop');
            $products = $_tempcart->getTempCart($_COOKIE['jshopping_temp_cart'], $this->type_cart);            
            if (count($products)){
                $this->products = $products;    
                $this->saveToSession();
            }            
        }
        
        $this->loadPriceAndCountProducts();        
    }
    
    function loadPriceAndCountProducts(){
        $this->price_product = 0;
        $this->count_product = 0;
        if(count($this->products)) {
            foreach ($this->products as $prod) {
                $this->price_product += $prod['price'] * $prod['quantity'];
                $this->count_product += $prod['quantity'];
            }
        }
    }
    
    function getPriceProducts(){
        return $this->price_product;
    }
    
    function getCountProduct(){
        return $this->count_product;
    }
    
    function getSum( $incShiping = 0, $incRabatt = 0 ) {
        $this->summ = $this->price_product;        
        if ($incShiping){
            $price_shipping = (isset($_SESSION['jshop_price_shipping']))?($_SESSION['jshop_price_shipping']):(0);
            $this->summ = $this->summ + $price_shipping;
        }
        if ($incRabatt){
            $this->summ = $this->summ - $this->rabatt_summ;
            if ($this->summ < 0) $this->summ = 0;
        }
        return $this->summ;
    }

    function getSumNetto() {
        $summ = 0;
        foreach ($this->products as $prod) {
            $summ += $prod['price_netto'] * $prod['quantity'];
        }
        return round($summ, 2);
    }

    function getShippingPrice() {
        return $_SESSION['jshop_price_shipping'];
    }

    function getShippingNettoPrice() {
        return $_SESSION['jshop_price_shipping'] / (1 + $_SESSION['jshop_price_shipping_tax_percent'] / 100);
    }

    function getTax( $incShiping = 0, $incRabatt = 0) {
        $tax_summ = 0;
        foreach ($this->products as $key => $value) {
            $tax_summ += $value['quantity'] * ($value['price'] - $value['price'] / (1 + $value['tax'] / 100));
        }
        if ($incShiping){
            $tax_summ += (isset($_SESSION['jshop_price_shipping_tax']))?$_SESSION['jshop_price_shipping_tax']:(0);
        }
        if ($incRabatt){
            $tax_summ -= $this->rabatt_tax_summ;
            if ($tax_summ<0) $tax_summ = 0;
        }
        return $tax_summ;
    }
    
    function getCouponId(){
        return $this->rabatt_id;
    }

    function calcNettoPrice(){
        foreach ($this->products as $key => $value) {
            $this->products[$key]['price_netto'] = round($value['price'] / (1 + $value['tax'] / 100), 2);
        }
    }

    function refreshCartWithNewCurrency() {
        foreach ($this->products as $key => $value) {
            $product = &JTable::getInstance('product', 'jshop');
            $product->load($this->products[$key]['product_id']);
            $attr_id = unserialize($value['attributes']);
            $product->setAttributeActive($attr_id);
            $this->products[$key]['price'] = $product->getPrice($this->products[$key]['quantity'], 1, 1);        
        }
        $this->loadPriceAndCountProducts();
        $this->reloadRabatValue();
        $this->saveToSession();
    }

    function add($product_id, $quantity, $attr_id){
        
        $jshopConfig = &JSFactory::getConfig();
        $attr_serialize = serialize($attr_id);
        
        if ($quantity <= 0) return 0;
        
        $currency = &JTable::getInstance('currency', 'jshop');
        $currency->load($jshopConfig->cur_currency);
        
        $product = &JTable::getInstance('product', 'jshop');
        $product->load($product_id);
        
        if (count($product->getRequireAttribute()) > count($attr_id) ){
            JError::raiseNotice('', _JSHOP_SELECT_PRODUCT_OPTIONS);
            return 0;
        }
        
        $product->setAttributeActive($attr_id);
        $qtyInStock = $product->getQtyInStock();        
        
        $new_product = 1;
        foreach ($this->products as $key => $value) {
            if ($value['product_id'] == $product_id && $value['attributes'] == $attr_serialize) {
                $sum_quantity = $this->products[$key]['quantity'] + $quantity;
                if ($jshopConfig->hide_product_not_avaible_stock && ($sum_quantity > $qtyInStock)){
                    $balans = $qtyInStock - $this->products[$key]['quantity'];
                    if ($balans<0) $balans = 0;
                    JError::raiseWarning('', sprintf(_JSHOP_ERROR_EXIST_QTY_PRODUCT, $balans));
                    return 0;
                } 
                $this->products[$key]['quantity'] = $sum_quantity;
                $product->getPrice($this->products[$key]['quantity'], 1, 1);                
                $this->products[$key]['price'] = $product->product_price;                
                $new_product = 0;
                break;
            }
        }

        if($new_product) {
            if ($jshopConfig->hide_product_not_avaible_stock && ($quantity > $qtyInStock)){
                JError::raiseWarning('', sprintf(_JSHOP_ERROR_EXIST_QTY_PRODUCT, $qtyInStock));
                return 0;
            }
            $product->getDescription();
            $product->getPrice($quantity, 1, 1);
            $product->getTax();
            $product->getCategory();            
            $temp_product['quantity'] = $quantity;
            $temp_product['product_id'] = $product_id;
            $temp_product['category_id'] = $product->category_id;
            $temp_product['price'] = $product->product_price;
            $temp_product['tax'] = $product->product_tax;
            $temp_product['description'] = $product->short_description;
            $temp_product['product_name'] = $product->name;
            $temp_product['thumb_image'] = $product->product_thumb_image;
            $temp_product['ean'] = $product->getEan();
            $temp_product['attributes'] = $attr_serialize;
            $temp_product['attributes_value'] = array();
            $temp_product['weight'] = $product->product_weight;        
            $i = 0;
            if (is_array($attr_id) && count($attr_id)) {
                foreach ($attr_id as $key => $value) {
                    $attr = &JTable::getInstance('attribut', 'jshop');
                    $attr_v = &JTable::getInstance('attributvalue', 'jshop');
                    $temp_product['attributes_value'][$i]->attr = $attr->getName($key);
                    $temp_product['attributes_value'][$i++]->value = $attr_v->getName($value);                    
                }
            }
            $this->products[] = $temp_product;
        }
        
        $this->loadPriceAndCountProducts();
        $this->reloadRabatValue();
        $this->saveToSession();
        return 1;
    }

    function refresh($quantity) {
        $jshopConfig = &JSFactory::getConfig();        
        if (is_array($quantity) && count($quantity)) {            
            $lang = &JSFactory::getLang();
            $name = $lang->get('name');
            foreach ($quantity as $key => $value) {
                $value = intval($value);
                if ($value < 0) $value = 0;
                $product = &JTable::getInstance('product', 'jshop');
                $product->load($this->products[$key]['product_id']);
                $attr = unserialize($this->products[$key]['attributes']);
                $product->setAttributeActive($attr);
                $qtyInStock = $product->getQtyInStock();                
                if ($jshopConfig->hide_product_not_avaible_stock && ($value > $qtyInStock)){
                    JError::raiseWarning('', sprintf(_JSHOP_ERROR_EXIST_QTY_PRODUCT_BASKET, $product->$name, $qtyInStock));
                    continue;
                }
                $product->getPrice($value, 1, 1);
                $this->products[$key]['price'] = $product->product_price;                
                $this->products[$key]['quantity'] = $value;
                if($this->products[$key]['quantity'] == 0){
                    unset($this->products[$key]);
                }
                unset($product);
            }
        }
        $this->loadPriceAndCountProducts();
        $this->reloadRabatValue();
        $this->saveToSession();
        return 1;
    }

    function getWeightProducts() {
        $weight_sum = 0;
        foreach ($this->products as $prod) {
            $weight_sum += $prod['weight'] * $prod['quantity'];
        }
        return $weight_sum;
    }

    function setRabatt($id, $type, $value, $tax) {        
        $this->rabatt_id = $id;
        $this->rabatt_type = $type;
        $this->rabatt_value = $value;
        $this->rabatt_tax = $tax;
        $this->reloadRabatValue();    
        $this->saveToSession();    
    }
    
    function reloadRabatValue(){
        $jshopConfig = &JSFactory::getConfig();
        
        if($this->rabatt_type == 1) {
            $this->rabatt_summ = $this->rabatt_value * $jshopConfig->currency_value; //value
        } else {
            $this->rabatt_summ = $this->rabatt_value / 100 * $this->price_product; //percent
        }
                        
        $this->rabatt_tax_summ = ($this->rabatt_summ / (100+$this->rabatt_tax)) * $this->rabatt_tax;
    }

    function addLinkToProducts($show_delete = 0, $type="cart") {
        foreach ($this->products as $key => $value) {
            $this->products[$key]['href'] = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$this->products[$key]['category_id'].'&product_id='.$value['product_id'], 1);
            if($show_delete){
                $this->products[$key]['href_delete'] = SEFLink('index.php?option=com_jshopping&controller='.$type.'&task=delete&number_id='.$key);
            }
            if ($type=="wishlist"){
                $this->products[$key]['remove_to_cart'] = SEFLink('index.php?option=com_jshopping&controller='.$type.'&task=remove_to_cart&number_id='.$key);                
            }
        }
    }
    
    function clear() {
        $this->products = array();
        $this->rabatt = 0;
        $this->rabatt_value = 0;
        $this->rabatt_type = 0;
        $this->rabatt_summ = 0;
        $this->summ = 0;
        $this->count_product = 0;        
        $this->price_product = 0;
        $this->rabatt_tax = 0;
        $this->rabatt_tax_summ = 0;        
        $_SESSION[$this->type_cart] = '';
        $_SESSION['pm_method'] = '';
        $_SESSION['pm_params'] = '';
        $_SESSION['payment_method_id'] = '';
        $_SESSION['shipping_method_id'] = '';
        $_SESSION['jshop_price_shipping'] = '';
    }

    function addOrderItem($order_id) {
        $arrProd = array();
        foreach ($this->products as $key => $value) {
            $order_item = &JTable::getInstance('orderItem', 'jshop');            
            $order_item->order_id = $order_id;
            $order_item->product_id = $value['product_id'];
            $order_item->product_ean = $value['ean'];
            $order_item->product_name = $value['product_name'];
            $order_item->product_quantity = $value['quantity'];
            $order_item->product_item_price = $value['price'];
            $order_item->product_tax = $value['tax'];
            $order_item->product_attributes = $attributes_value = '';
            if(isset($value['attributes_value'])) {
                foreach ($value['attributes_value'] as $attr) {
                    $attributes_value .= $attr->attr . ": " . $attr->value . "\n";
                }
            }
            $order_item->product_attributes = $attributes_value;
            if(!$order_item->store()) {
                echo $order_item->getError();
                exit();
            }
            
            $arrProd[$key]['quantity'] = $value['quantity'];
            $arrProd[$key]['product_id'] = $value['product_id'];
            $arrProd[$key]['attr'] = unserialize($value[attributes]);
        }

        // update count product in shop db
        $product = &JTable::getInstance('product', 'jshop');
        $product->updateProductInStock($arrProd);
    }

    function delete($number_id) {
        unset($this->products[$number_id]);
        $this->saveToSession();
    }

    function saveToSession() {
        $_SESSION[$this->type_cart] = serialize($this);        
        $_tempcart = &JModel::getInstance('tempcart', 'jshop');
        $_tempcart->insertTempCart($this);        
    }

}

?>